# Contributing to Kyverno

## Contributing Code

Unless you are fixing a known bug, we **strongly** recommend discussing it with
the core team via a GitHub issue or [in our chat](https://app.slack.com/client/T09NY5SBT/CLGR9BJU9)
before getting started to ensure your work is consistent with Kyverno
roadmap and architecture.

All contributions are made via pull request. Note that **all patches from all
contributors get reviewed**. After a pull request is made other contributors
will offer feedback, and if the patch passes review a maintainer will accept it
with a comment. When pull requests fail testing, authors are expected to update
their pull requests to address the failures until the tests pass and the pull
request merges successfully.

At least one review from a maintainer is required for all patches (even patches
from maintainers).

Reviewers should leave a "LGTM" comment once they are satisfied with the patch.
If the patch was submitted by a maintainer with write access, the pull request
should be merged by the submitter after review.

## Disclosing vulnerabilities

Please disclose vulnerabilities exclusively to [support@nirmata.com](mailto:support@nirmata.com). Do
not use GitHub issues.

## Code Style

We follow the community provided standard [code structure](https://github.com/golang-standards/project-layout).
